﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private ws As WebSocket 'ignore
	' will hold our page information
	Public page As ABMPage
	' page theme
	Private theme As ABMTheme
	' to access the constants
	Private ABM As ABMaterial 'ignore	
	' name of the page, must be the same as the class name (case sensitive!)
	Public Name As String = "CompImagePage"
	' name of the app, same as in ABMApplication
	Public AppName As String = "demo"
	
	' your own variables
	Dim myToastId As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	' build the local structure IMPORTANT!
	BuildPage
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	Log("Connected")
	ws = WebSocket1	
	If ABMShared.NeedsAuthorization Then
		If ws.Session.GetAttribute2("IsAuthorized", "") = "" Then
			ABMShared.NavigateToPage(ws, "../")
			Return
		End If
	End If
	' connect our page with the websocket	
	page.SetWebSocket(ws)
	' Prepare the page IMPORTANT!
	page.Prepare	
End Sub

Private Sub WebSocket_Disconnected
	Log("Disconnected")
End Sub

Sub Page_ParseEvent(Params As Map) 
	Dim eventName As String = Params.Get("eventname")
	Dim eventParams() As String = Regex.Split(",",Params.Get("eventparams"))
	If SubExists(Me, eventName) Then
		Params.Remove("eventname")
		Params.Remove("eventparams")
		Select Case Params.Size
			Case 0
				CallSub(Me, eventName)
			Case 1
				CallSub2(Me, eventName, Params.Get(eventParams(0)))					
			Case 2
				If Params.get(eventParams(0)) = "abmistable" Then
					Dim PassedTables As List = ABM.ProcessTablesFromTargetName(Params.get(eventParams(1)))
					CallSub2(Me, eventName, PassedTables)
				Else
					CallSub3(Me, eventName, Params.Get(eventParams(0)), Params.Get(eventParams(1)))
				End If
			Case Else
				' cannot be called diretly, to many param
				CallSub2(Me, eventName, Params)				
		End Select
	End If
End Sub

public Sub BuildTheme()
	' start with the base theme defined in ABMShared
	theme.Initialize("pagetheme")
	theme.AddABMTheme(ABMShared.MyTheme)
	
	' add additional themes specific for this page
	
End Sub

public Sub BuildPage()
	' initialize the theme
	BuildTheme
	
	' initialize this page using our theme
	page.InitializeWithTheme(Name, "/ws/" & AppName & "/" & Name, False, theme)
	page.ShowLoader=True
	page.PageTitle = "ABMImage"
	page.PageDescription = "The image component "	
	page.PageHTMLName = "abmaterial-image.html"
	page.PageKeywords = "ABMaterial, material design, B4X, B4J, SEO, framework, search engine optimization"
	page.PageSiteMapPriority = "0.50"
	page.PageSiteMapFrequency = ABM.SITEMAP_FREQ_MONTHLY
	page.UseGoogleAnalytics(ABMShared.TrackingID, Null) ' IMPORTANT Change this to your own TrackingID !!!!!!!
		
	ABMShared.BuildNavigationBar(page, "ABMImage", "../images/logo.png", "", "Controls", "ABMImage")
	
	' create the page grid	
	page.AddRows(5,True, "").AddCells12(1,"")
	page.AddRows(1,True, "").AddCellsOS(1,0,0,0,12,4,4,"").AddCellsOS(1,0,1,1,0,7,7,"")
	page.AddRows(1,True, "").AddCells12(1,"")
	page.AddRows(1,True, "").AddCellsOS(1,0,0,0,12,4,4,"").AddCellsOS(1,0,1,1,0,7,7,"")
	page.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	
	' add paragraph	
	page.Cell(1,1).AddComponent(ABMShared.BuildParagraph(page,"par1","Images can be styled in different ways using ABMaterial.") )	
		
	' add a sub header label
	page.Cell(1,1).AddComponent(ABMShared.BuildSubHeader(page,"hdr1", "Responsive Images"))
	
	' add paragraph	
	page.Cell(1,1).AddComponent(ABMShared.BuildParagraph(page,"par2","To make images resize responsively to page width, you can set the IsResponsive property to true. It will have a max width of 100% and the height will be changed automatically") )
	
	Dim img2 As ABMImage
	img2.Initialize(page, "img2", "../images/sample-1.jpg", 1)
	img2.IsResponsive=True
	page.Cell(2,1).AddComponent(img2)
	
	' add a sub header label
	page.Cell(3,1).AddComponent(ABMShared.BuildSubHeader(page,"hdr1", "Circular Images"))
	
	' add paragraph	
	page.Cell(3,1).AddComponent(ABMShared.BuildParagraph(page,"par2","To make images appear circular, simply set IsCircular to true.") )
	
	Dim img3 As ABMImage
	img3.Initialize(page, "img3", "../images/sample-1.jpg", 1)
	img3.IsResponsive=True
	img3.IsCircular=True
	page.Cell(4,1).AddComponent(img3)
	
	' add a sub header label
	page.Cell(5,1).AddComponent(ABMShared.BuildSubHeader(page,"hdr1", "Material Box"))
	
	' add paragraph	
	page.Cell(5,1).AddComponent(ABMShared.BuildParagraph(page,"par2","Material box is a material design implementation of the Lightbox plugin. When a user clicks on an image that can be enlarged. Material box centers the image and enlarges it in a smooth, non-jarring manner. To dismiss the image, the user can either click on the image again, scroll away, or press the ESC key. This is done by setting IsMaterialBoxed to true. ") )
	
	Dim img4 As ABMImage
	img4.Initialize(page, "img4", "../images/sample-1.jpg", 1)
	img4.IsResponsive=True
	img4.IsMaterialBoxed=True
	page.Cell(6,1).AddComponent(img4)

	' add paragraph	
	page.Cell(6,2).AddComponent(ABMShared.BuildParagraph(page,"par2","Click the image to see Material Box at work.") )	
	
	' add a sub header label
	page.Cell(7,1).AddComponent(ABMShared.BuildSubHeader(page,"hdr1", "Toggle"))
	
	' add paragraph	
	page.Cell(7,1).AddComponent(ABMShared.BuildParagraph(page,"par2","Using 'InitializeAsToggle()' will create a toggle image.") )
	
	Dim imgT As ABMImage
	imgT.InitializeAsToggle(page, "imgT", "../images/outline_star.png", "../images/star.png", True, 1)
	imgT.SetFixedSize(64,64)	
	page.Cell(8,1).AddComponent(imgT)
	
	' add paragraph	
	page.Cell(8,2).AddComponent(ABMShared.BuildParagraph(page,"par2","Click the image to toggle the star.") )	
	
	ABMShared.BuildFooter(page)
End Sub

' clicked on the navigation bar
Sub Page_NavigationbarClicked(Action As String, Value As String)
	page.SaveNavigationBarPosition	
	If Action = "GettingStarted" Then Return
	If Action = "Contact" Then		
		myToastId = myToastId + 1		
		page.ShowToast("toast" & myToastId, "toastred", "Hello to you too!", 5000)
		Return
	End If
	If Action = "LogOff" Then
		ABMShared.LogOff(page)
		Return
	End If
	ABMShared.NavigateToPage(ws, Value)
End Sub

Sub Page_SignedOffSocialNetwork(Network As String, Extra As String)
	page.ws.Session.SetAttribute("authType", "")
	page.ws.Session.SetAttribute("authName", "")
	page.ws.Session.SetAttribute("IsAuthorized", "")			
	ABMShared.NavigateToPage(page.ws, "../")
End Sub
Sub Page_Ready()
	Log("ready!")
	page.RestoreNavigationBarPosition
End Sub