﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private ws As WebSocket 'ignore
	' will hold our page information
	Public page As ABMPage
	' page theme
	Private theme As ABMTheme
	' to access the constants
	Private ABM As ABMaterial 'ignore	
	' name of the page, must be the same as the class name (case sensitive!)
	Public Name As String = "FolderPage"  '<-------------------------------------------------------- IMPORTANT
	' name of the app, same as in ABMApplication
	Public AppName As String = "folders"          '<-------------------------------------------------------- IMPORTANT
	
	' your own variables
	Dim PlusParents As Map	
	Type PlusStructure (Prefix As String, NextValue As Int)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	' build the local structure IMPORTANT!
	BuildPage
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	Log("Connected")
	ws = WebSocket1	
	If ABMShared.NeedsAuthorization Then
		If ws.Session.GetAttribute2("IsAuthorized", "") = "" Then
			ABMShared.NavigateToPage(ws, "../")
			Return
		End If
	End If
	' connect our page with the websocket	
	page.SetWebSocket(ws)	
	' Prepare the page IMPORTANT!
	page.Prepare	
	
	
	LoadInitialFolders
End Sub

Sub LoadInitialFolders
	
	PlusParents.Initialize
	PlusParents.Clear
	
	Dim view1 As ABMTreeTable = page.Component("view1")
	view1.Clear
	
	'NOTE that Root branches (Family, Nature) have to be put in the right sorting order! They can not make use of the autosort.
	' if you want them to sort, you have to create a root node:
	' e.g. Family, Nature would be sorted correctly because they have a parent Photos
	' Photos
	'      Nature
	' 			Sunsets
	'           Holidays
	'      Family
	'           Wedding
	view1.AddRow(BuildFolderOrFile(1, "", "1", "", "", "Family", Array As String("FOLDER", "FILE"), 1, "white")) ' start of our family block
	
	view1.AddRow(BuildFolderOrFile(2, "FOLDER", "1_1", "1", "", "Wedding", Array As String("FOLDER", "FILE"), 1, ""))	' start of our Wedding block
	view1.AddRow(BuildFolderOrFile(3, "FILE", "1_1_1", "1_1", "", "Image3.png", Array As String(), 0, "")) ' image
	view1.AddRow(BuildFolderOrFile(3, "FILE", "1_1_2", "1_1", "", "Image2.png", Array As String(), 0, "")) ' image
	view1.AddRow(BuildFolderOrFile(3, "FILE", "1_1_3", "1_1", "", "Image1.png", Array As String(), 0, "")) ' image	
	view1.AddRow(BuildFolderOrFile(2, "", "1_2", "1", "1_1", "+ (Add Image)", Array As String(), 0, ""))	' end of our Wedding block, footer with a plus
	' clicking on "1_2", next value should be "1_1" + "_4" as our last image is "1_1_3"
	PlusParents.Put("1_2", NewPlusStructure("1_1", 4))
	
	view1.AddRow(BuildFolderOrFile(1, "", "2", "", "1", "End Family", Array As String(), 0, "white")) ' end of our family block
		
	view1.AddRow(BuildFolderOrFile(1, "", "3", "", "", "Nature", Array As String("FOLDER", "FILE"), 1, "white")) ' start of nature block
	
	view1.AddRow(BuildFolderOrFile(2, "FOLDER", "3_1", "3", "", "Sunsets", Array As String("FOLDER", "FILE"), 1, "")) ' start of our sunsets block
	view1.AddRow(BuildFolderOrFile(3, "FILE", "3_1_1", "3_1", "", "Image9.png", Array As String(), 0, "")) ' image
	view1.AddRow(BuildFolderOrFile(3, "FILE", "3_1_2", "3_1", "", "Image8.png", Array As String(), 0, "")) ' image
	view1.AddRow(BuildFolderOrFile(3, "FILE", "3_1_3", "3_1", "", "Image7.png", Array As String(), 0, "")) ' image
	view1.AddRow(BuildFolderOrFile(2, "", "3_2", "3", "3_1", "+ (Add Image)", Array As String(), 0, ""))    ' end of our sunsets block, footer with a plus
	' clicking on "3_2", next value should be "3_1" + "_4" as our last image is "3_1_3"
	PlusParents.Put("3_2", NewPlusStructure("3_1", 4))
	
	view1.AddRow(BuildFolderOrFile(2, "FOLDER", "3_3", "3", "", "Holiday", Array As String("FOLDER", "FILE"), 1, "")) ' start of our Holdidays block
	view1.AddRow(BuildFolderOrFile(3, "FILE", "3_3_1", "3_3", "", "Image6.png", Array As String(), 0, "")) ' image
	view1.AddRow(BuildFolderOrFile(3, "FILE", "3_3_2", "3_3", "", "Image5.png", Array As String(), 0, "")) ' image
	view1.AddRow(BuildFolderOrFile(3, "FILE", "3_3_3", "3_3", "", "Image4.png", Array As String(), 0, "")) ' image	
	view1.AddRow(BuildFolderOrFile(2, "", "3_4", "3", "3_3", "+ (Add Image)", Array As String(), 0, "")) ' end of our Holidays block, footer with a plus
	' clicking on "3_4", next value should be "3_3" + "_4" as our last image is "3_3_3"
	PlusParents.Put("3_4", NewPlusStructure("3_3", 4))
	
	view1.AddRow(BuildFolderOrFile(1, "", "4", "", "3", "End Nature", Array As String(""), 0, "white"))  ' end of nature block
		
	view1.Refresh
End Sub

' helper method to find out what the new id should be of an added image
Sub NewPlusStructure(Prefix As String, NextValue As Int) As PlusStructure
	Dim ps As PlusStructure
	ps.Initialize
	ps.Prefix = Prefix
	ps.NextValue = NextValue
	Return ps
End Sub

Sub BuildFolderOrFile(Depth As Int, TreeType As String, RowId As String, ParentRowId As String, IsFooterForRowId As String, Title As String, CanReceiveDropsFrom As List, SortCellIndex As Int, iconThemeName As String) As ABMtreeTableRow
	Dim row As ABMtreeTableRow
	' initialization has changed!
	' IsFooter is changed from boolean to the row it is the footer of
	' TreeType is a type name of the line (like a folder, a file, etc).  This is needed for drag drop
	' Added a theme for the row (last param)
	row.Initialize(Depth, RowId, ParentRowId, IsFooterForRowId, TreeType, iconThemeName, "")
	' you can make the rows to be sorted automatically by setting on which column to sort (starting from 1)
	If SortCellIndex > 0 Then
		row.SortChildrenOn(SortCellIndex)
	End If
	' if the row can receive drop, specify here in a List what TreeType names can be dropped (see Initialize, TreeType)
	row.SetCanReceiveDropsFrom(CanReceiveDropsFrom)
	
	Dim cell1 As ABMTreeTableCell
	cell1.Initalize("v1_" & RowId & "c1", Title, Depth, 16-Depth, False, "")
	row.cells.Add(cell1)
	
	If Depth = 3 Then ' on image level, create an edit and delete button
		Dim cell4 As ABMTreeTableCell
		Dim btnEdit As ABMButton
		btnEdit.InitializeFloating(page, RowId, "mdi-action-visibility", "")
		btnEdit.size = ABM.BUTTONSIZE_SMALL
		cell4.InitalizeAsComponent("v1_" & RowId & "cEdit", btnEdit, "btnEdit", 18-Depth,1, "")
		row.cells.Add(cell4)
		
		Dim cell5 As ABMTreeTableCell
		Dim btnDelete As ABMButton
		btnDelete.InitializeFloating(page, RowId, "mdi-action-delete", "")
		btnDelete.size = ABM.BUTTONSIZE_SMALL
		cell5.InitalizeAsComponent("v1_" & RowId & "cDelete", btnDelete, "btnDelete", 19-Depth,1, "")
		row.cells.Add(cell5)
	End If
	
	Return row
End Sub

Sub view1_Clicked(TreeRowId As String, TreeCellId As String)
	' did he click on a plus, let him add the values of the new row
	If PlusParents.ContainsKey(TreeRowId) Then
		Dim ps As PlusStructure = PlusParents.Get(TreeRowId)
		
		' here you can show a modal sheet where the user adds new data in the browser
		' after saving the modal sheet, add the new data in the database and add a new leaf
		
		Log("The user added a new row: " & ps.Prefix & "_" & ps.NextValue)
		
		Dim view1 As ABMTreeTable = page.Component("view1")
		DateTime.timeFormat = "HH:mm:ss"
		view1.AddRow(BuildFolderOrFile(3, "FILE", ps.Prefix & "_" & ps.NextValue, ps.Prefix, "", "Image" & DateTime.time(DateTime.Now) & ".png", Array As String(), 0, ""))
		ps.NextValue = ps.NextValue + 1
		PlusParents.Put(TreeRowId, ps)
		view1.Refresh	
	End If
End Sub

' important! As the drag drop happens in the browser, we do have to update our internal memory map on the tree on the server also
Sub view1_Dropped(Params As Map)
	Dim Success As Boolean = Params.Get("success")
	Dim TreeRowId As String = Params.Get("treerowid")
	Dim FromTreeRowID As String = Params.get("fromtreerowid")
	Dim OnTreeRowID As String = Params.get("ontreerowid")
	Log("TreeRowId: " & TreeRowId & "from: " & FromTreeRowID & " dropped on: " & OnTreeRowID & " Success: " & Success)
	
	Dim view1 As ABMTreeTable = page.Component("view1")
	view1.Sync(TreeRowId, FromTreeRowID, OnTreeRowID) ' IMPORTANT so the tree in memory is the same as the tree in the browser
End Sub

' important! this is an event that is called when it wants you to refresh certain Components in a row
' e.g. a chart, a google map, ...
' if you use such components, uncomment the two inner lines
Sub view1_NeedsRefreshChildren(rowId As String)
	'Dim view1 As ABMTreeTable = page.Component("view1")
	'view1.RefreshChildren(rowId)
End Sub

' here a sheet can be shown to let the user modify the row
Sub btnEdit_Clicked(Target As String)
	' get the current row form the Target btnEdit1_1_1 -> 1_1_1
	Dim currRow As String = Mid2(Target, 8)
	Log("btnEdit: " & currRow)
	
	' do your stuff in the database
	
	' change it in the tree
	Dim view1 As ABMTreeTable = page.Component("view1")
	DateTime.timeFormat = "HH:mm:ss"
	view1.SetString(currRow, 1, "Image" & DateTime.time(DateTime.Now) & ".png")
	' refresh, only what is changed will be refreshed
	view1.Refresh
End Sub

Sub btnDelete_Clicked(Target As String)
	' get the current row form the Target btnDelete1_1_1 -> 1_1_1
	Dim currRow As String = Mid2(Target, 10)
	Log("btnDelete: " & currRow)
	
	' do your stuff in the database
	
	
	' delete it in the tree
	Dim view1 As ABMTreeTable = page.Component("view1")
	view1.RemoveRow(currRow)
	' refresh, only what is changed will be refreshed
	view1.Refresh
End Sub

Sub Mid2(Text As String, Start As Int) As String
   Return Text.SubString(Start-1)
End Sub

Private Sub WebSocket_Disconnected
	Log("Disconnected")
End Sub

Sub Page_ParseEvent(Params As Map) 
	Dim eventName As String = Params.Get("eventname")
	Dim eventParams() As String = Regex.Split(",",Params.Get("eventparams"))	
	If SubExists(Me, eventName) Then
		Params.Remove("eventname")
		Params.Remove("eventparams")
		Select Case Params.Size
			Case 0
				CallSub(Me, eventName)
			Case 1
				CallSub2(Me, eventName, Params.Get(eventParams(0)))					
			Case 2
				If Params.get(eventParams(0)) = "abmistable" Then
					Dim PassedTables As List = ABM.ProcessTablesFromTargetName(Params.get(eventParams(1)))
					CallSub2(Me, eventName, PassedTables)
				Else
					CallSub3(Me, eventName, Params.Get(eventParams(0)), Params.Get(eventParams(1)))
				End If
			Case Else
				' cannot be called diretly, to many param
				CallSub2(Me, eventName, Params)				
		End Select
	End If
End Sub

public Sub BuildTheme()
	' start with the base theme defined in ABMShared
	theme.Initialize("pagetheme")
	theme.AddABMTheme(ABMShared.MyTheme)
	
	' add additional themes specific for this page
	theme.AddTreeTableTheme("view1")
	theme.TreeTable("view1").AddCellTheme("lev1default")
		
	theme.TreeTable("view1").Cell("lev1default").BackColor = ABM.COLOR_LIGHTBLUE
	theme.TreeTable("view1").Cell("lev1default").BackColorIntensity = ABM.INTENSITY_DARKEN3
	theme.TreeTable("view1").Cell("lev1default").ForeColor = ABM.COLOR_WHITE
	theme.TreeTable("view1").Cell("lev1default").IsEditable = True
		
	theme.TreeTable("view1").AddCellTheme("lev2default")
	theme.TreeTable("view1").Cell("lev2default").BackColor = ABM.COLOR_LIGHTBLUE
	theme.TreeTable("view1").Cell("lev2default").BackColorIntensity = ABM.INTENSITY_LIGHTEN2
		
	theme.TreeTable("view1").AddCellTheme("lev3default")
	theme.TreeTable("view1").Cell("lev3default").BackColor = ABM.COLOR_LIGHTBLUE
	theme.TreeTable("view1").Cell("lev3default").BackColorIntensity = ABM.INTENSITY_LIGHTEN4
	
	theme.TreeTable("view1").AddCellTheme("lev4default")
	theme.TreeTable("view1").Cell("lev4default").BackColor = ABM.COLOR_WHITE
	
	theme.TreeTable("view1").AddTreeIconColorTheme("white")
	theme.TreeTable("view1").TreeIconColor("white").ForeColor = ABM.COLOR_WHITE
End Sub

public Sub BuildPage()
	' initialize the theme
	BuildTheme
	
	' initialize this page using our theme
	page.InitializeWithTheme(Name, "/ws/" & AppName & "/" & Name, False, theme)
	page.ShowLoader=True
	page.PageHTMLName = "index.html"
	page.PageTitle = ""
	page.PageDescription = ""
	page.PageKeywords = ""
	page.PageSiteMapPriority = ""
	page.PageSiteMapFrequency = ABM.SITEMAP_FREQ_YEARLY
		
	' adding a navigation bar
	
			
	' create the page grid
	page.AddRows(5,True, "").AddCells12(1,"")
	page.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	
	' build an empty example tree	
	Dim view1 As ABMTreeTable
	
	view1.Initialize(page, "view1", False, "view1", 20, Array As String("lev1default", "lev2default", "lev3default", "lev4default"), 20)
	view1.CollapseTooltip = "Close"
	view1.ExpandTooltip = "Open"	
	' notice we do not add any rows here!	
	page.CellR(1,1).AddComponent(view1)
	
	Dim btnGetTree As ABMButton
	btnGetTree.InitializeRaised(page, "btnGetTree", "", "", "Get Tree", "")
	page.CellR(1,1).AddComponent(btnGetTree)		
	
End Sub

' use tree.GetBracnch to get a List containing all the rows in the branch.
' Gets a sequential list of rowIds from a branch, including all siblings
' If the rowId has a footer, it will also be returned
' Using an empty string As rowId will Return the whole tree 
'
' NOTE: If you did not use sorting, the returned order is not guaranteed the order you see in the tree in the browser!
Sub btnGetTree_Clicked(Target As String)
	Dim view1 As ABMTreeTable = page.Component("view1")
	Dim l As List = view1.GetBranch("")
	For j = 0 To l.Size - 1
		Log(l.Get(j))		
	Next
End Sub

' clicked on the navigation bar
Sub Page_NavigationbarClicked(Action As String, Value As String)
	page.SaveNavigationBarPosition
	
End Sub

Sub Page_FileUploaded(FileName As String, success As Boolean)	
	
End Sub

Sub Page_ToastClicked(ToastId As String, Action As String)
		
End Sub

Sub Page_ToastDismissed(ToastId As String)	
	
End Sub

Sub Page_Ready()
	Log("ready!")
	page.RestoreNavigationBarPosition
End Sub